// mdac.cpp

#include "stdafx.h"
#include "CFileVersion.h"
#include <windows.h>
#include "MTSetup.h"

extern DWORD g_dwOSVerFlags;
extern CRITICAL_SECTION	g_cs;
extern DWORD	g_dwInitRebootReason;
extern TCHAR szFileName[MAX_PATH];

BOOL InstallMDAC()
{
	BOOL bRetVal = FALSE;
	DWORD dwExitCode = 0;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	BOOL bCreateProc = FALSE;
	//BOOL bProcessExitCode;

	// try writing Win95 registry here.
	if((g_dwOSVerFlags & dwWin95) == dwWin95)
		if(!SetRunOnceKey(dwMDAC))
			MessageBox(NULL, TEXT("MDAC RunOnce Key not set for Win95"), TEXT("Error"), MB_ICONERROR);
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	bCreateProc = CreateProcess(NULL,
		szFileName,
		NULL,
		NULL,
		FALSE,
		0,   
		NULL,
		NULL,
		&si,
		&pi);

	if(bCreateProc)
	{
		// MDAC Installation has started
		CloseHandle(pi.hThread);
		EnterCriticalSection(&g_cs);
		g_dwInitRebootReason = dwMDAC;
		LeaveCriticalSection(&g_cs);
		WaitForSingleObject(pi.hProcess, INFINITE);
		CloseHandle(pi.hProcess);
		return TRUE;
	}
	else
	{
		DWORD dwErrCode = 0;
		char szErr[25];
		dwErrCode = GetLastError();
		wsprintf(szErr, TEXT("MDAC Installation failed. Error Code:%u"), dwErrCode);
		MessageBox(NULL, szErr, TEXT("MDAC Failed"), MB_OK);
		return FALSE;
	}
}

BOOL IsWinLanguageDutch()
// This function gets the language of the installed windows, so not the Locale settings!
// This is done by checking the language of User.exe (Microsofts advice)
{
	TCHAR szCheckUserExe[MAX_PATH];
	CFileVersion objFileCheck;
	DWORD UserExeLang = 0;
	TCHAR SystemDir[MAX_PATH];

	if(GetSystemDirectory(SystemDir,MAX_PATH)) {
		wsprintf(szCheckUserExe,TEXT("%s\\USER.EXE"),SystemDir);

		if (objFileCheck.Open(szCheckUserExe)) {
			UserExeLang = objFileCheck.GetFileLanguage();
			objFileCheck.Close();
		}
	}
	return (UserExeLang == 1043);
}

BOOL IsMDACPresent()
{
	BOOL bRetVal = FALSE;
	TCHAR szMDACRegKey[] = TEXT("Software\\Microsoft\\DataAccess");
	TCHAR szValue[MAX_PATH];
	DWORD dwValue = 0;
	HKEY hKLM = NULL;
	LONG lReg = 0;
	LONG ldwReg = 0;
	LONG lszReg = 0;
	BOOL lNewMDACVer = 0;
	DWORD dwKeySize = 0;
	TCHAR szCurrentDir[MAX_PATH];
	TCHAR szExt[MAX_PATH];
	TCHAR szCheckFileName[MAX_PATH];
	CFileVersion objFileCheck;
	TCHAR MDAC_TypVer[MAX_PATH] = TEXT("");

	// What is the MDAC extention (Dutch or English)
	// Determine which language of Windows we have here.
	if(IsWinLanguageDutch()) {
		lstrcpy(szExt, TEXT("_NL.EXE"));
	}
	else 
		lstrcpy(szExt, TEXT(".EXE"));

	GetCurrentDirectory(sizeof(szCurrentDir), szCurrentDir);
	if(NULL == szCurrentDir[3])
	{	// at root directory
		wsprintf(szFileName, TEXT("%sUTILS\\MDAC_TYP%s /Q /C:\"setup /QT\"/R"), szCurrentDir, szExt);
		wsprintf(szCheckFileName, TEXT("%sUTILS\\MDAC_TYP%s"), szCurrentDir, szExt);
	}
	else {
		wsprintf(szFileName, TEXT("\"%s\\UTILS\\MDAC_TYP%s\" /Q /C:\"setup /QT\"/R"), szCurrentDir, szExt);
		wsprintf(szCheckFileName, TEXT("%s\\UTILS\\MDAC_TYP%s"), szCurrentDir, szExt);
	}

#ifdef _DEBUG
	MessageBox(NULL, szCheckFileName, TEXT("MDAC Filename"), MB_OK);
#endif

	//Check the version of the MDAC_TYP.EXE
	if (objFileCheck.Open(szCheckFileName)) {
		lstrcpy(MDAC_TypVer, objFileCheck.GetFileVersion());
#ifdef _DEBUG
	MessageBox(NULL, szCheckFileName, MDAC_TypVer, MB_OK);
#endif
		objFileCheck.Close();
	}

	if((g_dwOSVerFlags & dwWin2K) == dwWin2K)
	{
		return TRUE;
	}

	lReg = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
				szMDACRegKey,
				0,
				KEY_READ,
				&hKLM);


	if(ERROR_SUCCESS == lReg)
	{
		dwKeySize = sizeof(szValue)/sizeof(TCHAR);
		lszReg = RegQueryValueEx(hKLM, TEXT("FullInstallVer"), NULL, NULL, (BYTE*) szValue, &dwKeySize);
		ldwReg = RegQueryValueEx(hKLM, TEXT("Full21Install"), NULL, NULL, (BYTE*) dwValue, &dwKeySize);

		
		// Is the version included with the installation files newer then the installed version?
		lNewMDACVer = lstrcmp(MDAC_TypVer, szValue)>0;

		if(((ERROR_SUCCESS == lszReg) || (ERROR_SUCCESS == ldwReg)) && !(lNewMDACVer))
		{
			RegCloseKey(hKLM);
			return TRUE;
		}
		else
		{
			TCHAR szMessage[MAX_PATH];
			wsprintf(szMessage,TEXT("New MDAC Version will now be installed:\nInstalled Version = %s\nNew version = %s"), szValue, MDAC_TypVer);
			MessageBox(NULL, szMessage, TEXT("MDAC compare"), MB_OK);
			
			RegCloseKey(hKLM);
			return FALSE;
		}
	}
	else
	{
		return FALSE;
	}
}
